GEOS: geos::geom::LineString Class Reference

GEOS 3.5.0

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
geos::geom::LineString Class Reference

`#include <LineString.h>`

Inheritance diagram for geos::geom::LineString:

## Public Types
typedef std::vector< const LineString * > | ConstVect
| A vector of const LineString pointers.
Public Types inherited from geos::geom::Geometry
typedef std::vector< const Geometry * > | ConstVect
| A vector of const Geometry pointers.
typedef std::vector< Geometry * > | NonConstVect
| A vector of non-const Geometry pointers.
typedef std::auto_ptr< Geometry > | AutoPtr
| An auto_ptr of Geometry.

## Public Member Functions
virtual Geometry * | clone () const
virtual CoordinateSequence * | getCoordinates () const
| Returns this Geometry vertices. Caller takes ownership of the returned object.
const CoordinateSequence * | getCoordinatesRO () const
| Returns a read-only pointer to internal CoordinateSequence.
virtual const Coordinate & | getCoordinateN (int n) const
virtual Dimension::DimensionType | getDimension () const
| Returns line dimension (1)
virtual int | getBoundaryDimension () const
| Returns Dimension::False for a closed LineString, 0 otherwise (LineString boundary is a MultiPoint)
virtual int | getCoordinateDimension () const
| Returns coordinate dimension.
virtual Geometry * | getBoundary () const
| Returns a MultiPoint. Empty for closed LineString, a Point for each vertex otherwise.
virtual bool | isEmpty () const
| Returns whether or not the set of points in this Geometry is empty.
virtual std::size_t | getNumPoints () const
| Returns the count of this Geometrys vertices.
virtual Point * | getPointN (std::size_t n) const
virtual Point * | getStartPoint () const
| Return the start point of the LineString or NULL if this is an EMPTY LineString.
virtual Point * | getEndPoint () const
| Return the end point of the LineString or NULL if this is an EMPTY LineString.
virtual bool | isClosed () const
virtual bool | isRing () const
virtual std::string | getGeometryType () const
| Return a string representation of this Geometry type.
virtual GeometryTypeId | getGeometryTypeId () const
| Return an integer representation of this Geometry type.
virtual bool | isCoordinate (Coordinate &pt) const
virtual bool | equalsExact (const Geometry *other, double tolerance=0) const
| Returns true if the two Geometrys are exactly equal, up to a specified tolerance.
virtual void | apply_rw (const CoordinateFilter *filter)
virtual void | apply_ro (CoordinateFilter *filter) const
virtual void | apply_rw (GeometryFilter *filter)
virtual void | apply_ro (GeometryFilter *filter) const
virtual void | apply_rw (GeometryComponentFilter *filter)
virtual void | apply_ro (GeometryComponentFilter *filter) const
void | apply_rw (CoordinateSequenceFilter &filter)
void | apply_ro (CoordinateSequenceFilter &filter) const
virtual void | normalize ()
| Normalizes a LineString. More...
virtual int | compareToSameClass (const Geometry *ls) const
virtual const Coordinate * | getCoordinate () const
| Returns a vertex of this Geometry, or NULL if this is the empty geometry.
virtual double | getLength () const
| Returns the length of this Geometry.
Geometry * | reverse () const
Public Member Functions inherited from geos::geom::Geometry
virtual | ~Geometry ()
| Destroy Geometry and all components.
const GeometryFactory * | getFactory () const
| Gets the factory which contains the context in which this geometry was created. More...
void | setUserData (void *newUserData)
| A simple scheme for applications to add their own custom data to a Geometry. An example use might be to add an object representing a Coordinate Reference System. More...
void * | getUserData ()
| Gets the user data object for this geometry, if any. More...
virtual int | getSRID () const
virtual void | setSRID (int newSRID)
const PrecisionModel * | getPrecisionModel () const
| Get the PrecisionModel used to create this Geometry.
virtual bool | isSimple () const
| Returns false if the Geometry not simple.
virtual std::size_t | getNumGeometries () const
virtual const Geometry * | getGeometryN (std::size_t) const
virtual bool | isValid () const
| Tests the validity of this `Geometry`. More...
virtual bool | isRectangle () const
| Polygon overrides to check for actual rectangle.
virtual Geometry * | getEnvelope () const
| Returns this Geometrys bounding box.
virtual const Envelope * | getEnvelopeInternal () const
| Returns the minimum and maximum x and y values in this Geometry, or a null Envelope if this Geometry is empty.
virtual bool | disjoint (const Geometry *other) const
virtual bool | touches (const Geometry *other) const
| Returns true if the DE-9IM intersection matrix for the two Geometrys is FT*******, F**T***** or F***T****.
virtual bool | intersects (const Geometry *g) const
| Returns true if disjoint returns false.
virtual bool | crosses (const Geometry *g) const
virtual bool | within (const Geometry *g) const
| Returns true if the DE-9IM intersection matrix for the two Geometrys is T*F**F***.
virtual bool | contains (const Geometry *g) const
| Returns true if other.within(this) returns true.
virtual bool | overlaps (const Geometry *g) const
| Returns true if the DE-9IM intersection matrix for the two Geometrys is T*T***T** (for two points or two surfaces) 1*T***T** (for two curves).
virtual bool | relate (const Geometry *g, const std::string &intersectionPattern) const
| Returns true if the elements in the DE-9IM intersection matrix for the two Geometrys match the elements in intersectionPattern. More...
bool | relate (const Geometry &g, const std::string &intersectionPattern) const
virtual IntersectionMatrix * | relate (const Geometry *g) const
| Returns the DE-9IM intersection matrix for the two Geometrys.
IntersectionMatrix * | relate (const Geometry &g) const
virtual bool | equals (const Geometry *g) const
| Returns true if the DE-9IM intersection matrix for the two Geometrys is T*F**FFF*.
bool | covers (const Geometry *g) const
| Returns `true` if this geometry covers the specified geometry. More...
bool | coveredBy (const Geometry *g) const
| Tests whether this geometry is covered by the specified geometry. More...
virtual std::string | toString () const
| Returns the Well-known Text representation of this Geometry.
virtual std::string | toText () const
virtual Geometry * | buffer (double distance) const
| Returns a buffer region around this Geometry having the given width. More...
virtual Geometry * | buffer (double distance, int quadrantSegments) const
| Returns a buffer region around this Geometry having the given width and with a specified number of segments used to approximate curves. More...
virtual Geometry * | buffer (double distance, int quadrantSegments, int endCapStyle) const
| Computes a buffer area around this geometry having the given width and with a specified accuracy of approximation for circular arcs, and using a specified end cap style. More...
virtual Geometry * | convexHull () const
| Returns the smallest convex Polygon that contains all the points in the Geometry.
virtual Geometry * | intersection (const Geometry *other) const
| Returns a Geometry representing the points shared by this Geometry and other. More...
Geometry * | Union (const Geometry *other) const
| Returns a Geometry representing all the points in this Geometry and other. More...
AutoPtr | Union () const
virtual Geometry * | difference (const Geometry *other) const
| Returns a Geometry representing the points making up this Geometry that do not make up other. More...
virtual Geometry * | symDifference (const Geometry *other) const
| Returns a set combining the points in this Geometry not in other, and the points in other not in this Geometry. More...
template<class T >
void | applyComponentFilter (T &f) const
| Apply a fiter to each component of this geometry. The filter is expected to provide a .filter(const Geometry*) method. More...
virtual int | compareTo (const Geometry *geom) const
virtual double | distance (const Geometry *g) const
| Returns the minimum distance between this Geometry and the Geometry g.
virtual double | getArea () const
| Returns the area of this Geometry.
virtual bool | isWithinDistance (const Geometry *geom, double cDistance) const
| Tests whether the distance from this Geometry to another is less than or equal to a specified value. More...
virtual Point * | getCentroid () const
| Computes the centroid of this `Geometry`. More...
virtual bool | getCentroid (Coordinate &ret) const
| Computes the centroid of this Geometry as a Coordinate. More...
virtual Point * | getInteriorPoint () const
| Computes an interior point of this `Geometry`. More...
virtual void | geometryChanged ()
void | geometryChangedAction ()
| Notifies this Geometry that its Coordinates have been changed by an external party.

## Protected Member Functions
| LineString (const LineString &ls)
| LineString (CoordinateSequence *pts, const GeometryFactory *newFactory)
| Constructs a LineString taking ownership the given CoordinateSequence.
| LineString (CoordinateSequence::AutoPtr pts, const GeometryFactory *newFactory)
| Hopefully cleaner version of the above.
Envelope::AutoPtr | computeEnvelopeInternal () const
Protected Member Functions inherited from geos::geom::Geometry
virtual bool | isEquivalentClass (const Geometry *other) const
| Returns whether the two Geometrys are equal, from the point of view of the equalsExact method.
int | compare (std::vector< Coordinate > a, std::vector< Coordinate > b) const
int | compare (std::vector< Geometry * > a, std::vector< Geometry * > b) const
bool | equal (const Coordinate &a, const Coordinate &b, double tolerance) const
| Geometry (const Geometry &geom)
| Polygon overrides to check for actual rectangle. More...
| Geometry (const GeometryFactory *factory)
| Construct a geometry with the given GeometryFactory. More...

## Protected Attributes
CoordinateSequence::AutoPtr | points
Protected Attributes inherited from geos::geom::Geometry
std::auto_ptr< Envelope > | envelope
| The bounding box of this Geometry.
int | SRID

## Friends
class | GeometryFactory

## Additional Inherited Members
Static Protected Member Functions inherited from geos::geom::Geometry
static bool | hasNonEmptyElements (const std::vector< Geometry * > *geometries)
| Returns true if the array contains any non-empty Geometrys.
static bool | hasNullElements (const CoordinateSequence *list)
| Returns true if the CoordinateSequence contains any null elements.
static bool | hasNullElements (const std::vector< Geometry * > *lrs)
| Returns true if the vector contains any null elements.
static void | checkNotGeometryCollection (const Geometry *g)

## Detailed Description

Models an OGC-style `LineString`.

A LineString consists of a sequence of two or more vertices, along with all points along the linearly-interpolated curves (line segments) between each pair of consecutive vertices. Consecutive vertices may be equal. The line segments in the line may intersect each other (in other words, the linestring may "curl back" in itself and self-intersect. Linestrings with exactly two identical points are invalid.

A linestring must have either 0 or 2 or more points. If these conditions are not met, the constructors throw an IllegalArgumentException

## Member Function Documentation

void geos::geom::LineString::apply_ro | ( | CoordinateSequenceFilter & | filter | ) | const
| virtual

Performs a read-only operation on the coordinates in this Geometry's CoordinateSequences.

Parameters

  filter | the filter to apply

Implements geos::geom::Geometry.

void geos::geom::LineString::apply_rw | ( | CoordinateSequenceFilter & | filter | ) |
| virtual

Performs an operation on the coordinates in this Geometry's CoordinateSequences.s If the filter reports that a coordinate value has been changed, geometryChanged will be called automatically.

Parameters

  filter | the filter to apply

Implements geos::geom::Geometry.

Geometry * geos::geom::LineString::clone | ( |  | ) | const
| inlinevirtual

Creates and returns a full copy of this LineString object. (including all coordinates contained by it).

Returns
  a clone of this instance

Implements geos::geom::Geometry.

Reimplemented in geos::geom::LinearRing.

virtual void geos::geom::LineString::normalize | ( |  | ) |
| virtual

Normalizes a LineString.

A normalized linestring has the first point which is not equal to it's reflected point less than the reflected point.

Implements geos::geom::Geometry.

Geometry* geos::geom::LineString::reverse | ( |  | ) | const

Creates a LineString whose coordinates are in the reverse order of this objects

Returns
  a LineString with coordinates in the reverse order

The documentation for this class was generated from the following file:

- LineString.h